# This AWK script will create a compressed backup tree with ZIP archiver
# limiting the max size of the .zip files to GRANULATION.
# If directorty is too big then subdirectories are recursively compressed.
# Files in big directories are splited into several archives if needed.
# Note that ZIP file size is limited to 2^32 bytes (2GB)
# usage: awk -f colapse.awk
# author: (C) 2003, Leon Kos
# License: GPL

BEGIN{

  SRC="/home/staff";
  DST="/home/staff-backup";

# File size granuality in Megabytes
  GRANULATION=10;
 
  GRANULATION *= 1024*1024;

  ZIP_OPTS="-1q";
 
  FS="\t";
 
 
  system("rm -rf " DST);
 
  findcmd = "find " SRC " -type d -printf \"%P\\n\""; 
  while((findcmd | getline) > 0)
    {
      dir_name= $0;
      cmd = "du -sb \"" SRC "/" dir_name "\"";
      cmd | getline; 
      size = $1;
      close(cmd);
      if (size > GRANULATION) # large directory
	{
	  tree["/" dir_name] = size;
	  cmd = "mkdir \"" DST "/" dir_name "\"";
	  print cmd;
	  print DST "/" dir_name
#	    system(cmd);
#	  collect_files(SRC, DST, dir_name);
	}
      else # Small leaf directories are recursively stored into archives
	{
	  depth = split(dir_name, A, "/");
	  parent="";
	  for (i = 1; i < depth; i++)
	    parent = parent "/" A[i];

	  if (tree[parent] || parent == "")
	    {
	      cmd = "cd " SRC "; zip " ZIP_OPTS " -r \"" \
		DST "/" dir_name ".zip\" \"" dir_name "\"";
#	      print cmd, "size:", size;
#	      system(cmd);

	    }
	  else
	    {
#	      print dir_name " covered by " parent ".zip size:", size
	    }
	    
	}
    }

  close(findcmd);
  exit(0);

}

# Collect files in big directoies and create splitted archives
# without subdirectories
function collect_files(src, dst, dir_name)
{
  cmd = "find \"" src "/" dir_name "\" -type f -maxdepth 1 -printf \"%s\\t%P\\n\"";
#  print cmd;
  total = 0;
  archive_number=0;
  file_list = "";
  while((cmd | getline) > 0)
    {
      size = $1;
      if (dir_name == "")
	file_name = $2;
      else
	file_name = dir_name "/" $2;
      file_list = file_list file_name "\n";
      total += size;
      if (total > GRANULATION)
	{
	  zipcmd = "cd " src "; echo \"" file_list \
	    "\" | zip " ZIP_OPTS " -@ " dst "/" dir_name "/#" archive_number;
#	  print  zipcmd;
	  system(zipcmd);

	  file_list = "";
	  total = 0;
	  archive_number ++;
	}
    }
  close(cmd);
  if (total > 0)
    {
      zipcmd = "cd " src "; echo \"" file_list \
	"\" | zip " ZIP_OPTS " -@ " dst "/" dir_name "/#" archive_number;
#     print zipcmd;
      system(zipcmd);
    }
}
